COLUMN(1)

NUME
column - afișează listele în coloane

REZUMAT

column [opțiuni] [filșier ...]

DESCRIERE

Aplicația column formatează datele de intrare în mai multe coloane. Aceasta are trei moduri:

completează coloanele înaintea rândurilor
    Acesta este modul implicit (necesar pentru compatibilitatea cu versiunile anterioare).

completează rândurile înainte de a completa coloanele
    Acest mod este activat cu opțiunea -x, --fillrows.

create a table
    Determină numărul de coloane pe care le conține intrarea și creează un tabel. Acest mod este activat prin opțiunea -t/--table. Ieșirea este aliniată la lățimea terminalului în modul interactiv, și la 80 de coloane în modul non-interactiv (a se vedea --output-width pentru mai multe detalii). Formatarea personalizată poate fi aplicată folosind mai multe opțiuni --table-*.

Datele de intrare sunt preluate din fișier sau, în caz contrar, de la intrarea standard. Liniile goale sunt ignorate, iar toate secvențele multiocteți nevalide sunt codificate cuconvenția x<hex>.

OPȚIUNI

Argumentul coloane, pentru opțiunile --table-* de mai jos, este o listă separată prin virgule de nume furnizate de utilizator, definite cu --table-columns nume1_,nume2,..., sau indicii coloanelor așa cum apar în datele de intrare, începând cu 1, sau nume definite prin intermediul unui atribut --table-column. Este posibil să se combine nume și indici. Se poate folosi substituentul special „0” (de ex. -R0) pentru a specifica toate coloanele și „-1” (de ex. -R -1) pentru a specifica ultima coloană vizibilă. Este posibil să se folosească intervale precum „1-5” la adresarea coloanelor prin indici.

-J, --json
    Utilizează formatul de ieșire JSON pentru a afișa tabelul, Opțiunea --table-columns este necesară, iar opțiunea --table-name este recomandată.

-c, --output-width lățimea
    Ieșirea este formatată la o lățime specificată ca număr de caractere. Rețineți că intrarea mai lungă decât lățimea nu este trunchiată în mod implicit. Valoarea implicită este lățimea terminalului în modul interactiv și 80 de coloane în modul neinteractiv. Titlurile coloanelor nu sunt niciodată trunchiate.

    Valoarea rezervată unlimited(nelimitat) (sau 0) poate fi utilizată pentru a preveni restricționarea lățimii de ieșire. Acest lucru este recomandat atunci când redirecționați ieșirea către un fișier

    (Denumirea lungă inițială a acestei opțiuni era --columns; această denumire nu mai este recomandată începând cu versiunea 2.30.)

-d, --table-noheadings
    Omite afișarea antetului. Această opțiune permite specificarea numelor de coloane de către utilizator în linia de comandă, dar menține antetul ascuns la afișarea tabelului.

-o, --output-separator șir
    Delimitator de coloană pentru ieșirea tabelului (implicit două spații).

-s, --input-separator, --separator separatori
    Posibilii delimitatori ai elementelor de intrare (valoarea implicită este spațiul în alb).

-S, --use-spaces număr
    Atunci când nu este în modul tabel, utilizează spații în loc de tabulatoare pentru a alinia coloanele. Această opțiune specifică numărul minim de spații care separă două coloane.

-t, --table
    Determină numărul de coloane pe care le conține fișierul de intrare și creează un tabel. În mod implicit, coloanele sunt delimitate cu spații albe sau cu caractere furnizate folosind opțiunea --output-separator. Ieșirea tabelului este utilă pentru afișarea de tip „pretty-printing”, imprimare-formatată-plăcut.

--table-colorscheme nume
    Specifică numele schemei de culori. Pentru mai multe detalii, consultați secțiunea CULORI.

-C, --table-column atribute
    Definește o coloană printr-o listă de atribute separate prin virgule. Această opțiune poate fi utilizată de mai multe ori, fiecare utilizare definind o singură coloană. Atributele înlocuiesc unele dintre opțiunile --table-: de exemplu, *--table-column name=FOO,right definește o coloană în care textul este aliniat la dreapta. Opțiunea se exclude reciproc cu -N/--table-columns.

    Atributele acceptate sunt:

    name=șir
        Numele coloanei.

    trunc
        Trunchiază textul coloanei atunci când este necesar. La fel ca --table-truncate. Rețineți că antetul coloanei nu este niciodată trunchiat și reprezintă lățimea minimă a coloanei.

    tree
        Utilizează această coloană pentru afișarea sub formă de arbore. Consultați --tree pentru mai multe detalii.

    right
        Aliniază textul la dreapta. La fel ca --table-right.

    width=număr
        Lățimea coloanei. Este folosită doar ca recomandare. Pentru a o impune, specificați de asemenea atributul strictwidth. Lățimea minimă efectivă este lățimea titlului coloanei.

    strictwidth
        Respectă cu strictețe atributul width= pentru a stabili dimensiunea minimă a coloanei. Coloana poate fi mai largă dacă lățimea de afișare oferă suficient spațiu.

    noextremes
        Ignoră lățimea neobișnuit de mare a conținutului. A se vedea, pentru mai multe detalii --table-noextreme.

    hidden
        Nu afișează coloanele. A se vedea --table-hide pentru mai multe detalii.

    wrap
        Permite utilizarea unei celule pe mai multe rânduri pentru textul lung, dacă este necesar. Rețineți că titlul coloanei nu se încadrează niciodată și determină lățimea minimă a coloanei. Consultați --table-wrap pentru mai multe detalii.

    wrapnl
        Încadrează la caracterele de linie nouă; caracterele de linie nouă din datele celulei sunt tratate ca întreruperi de linie.

    wrapzero
        Încadrare la caracterul NUL, pentru caracterele din datele celulei.

    json=tip
        Definește tipul coloanei pentru ieșirea JSON. Tipurile acceptate sunt string, number, float, array-string, array-number și boolean.

    color=nume
        Definește culoarea coloanei pentru afișarea pe terminal. nume este un nume de culoare (black, blink, blue, bold, brown, cyan, darkgray, gray, green, halfbright, lightblue, lightcyan, lightgray, lightgreen, lightmagenta, lightred, magenta, red, reset, reverse și yellow) sau unul sau mai multe numere de secvență de culori ANSI separate prin punct și virgulă, dar fără prefixul „ESC[” și sufixul „m”. De exemplu, „37;41” definește secvențe pentru un fundal roșu și un prim-plan alb. Pentru mai multe detalii, consultați secțiunea CULORI.

    colorkey=nume
        Tratează culorile conform definiției din schema de culori. A se vedea --table-colorscheme.

    headercolor=nume
        La fel ca color=, dar definește culoarea doar pentru titlul coloanei.

    headercolorkey=nume
        Stabilește culoarea antetului conform schemei de culori definite. A se vedea --table-colorscheme.

-N, --table-columns nume
    Specifică numele coloanelor printr-o listă de nume separate prin virgule. Numele sunt utilizate pentru antetul tabelului și pentru adresarea coloanelor în argumentele opțiunilor. A se vedea, de asemenea, --table-column.

-l, --table-columns-limit număr
    Specifică numărul maxim de coloane de intrare. Ultima coloană va conține toate datele de linie rămase dacă limita este mai mică decât numărul de coloane din datele de intrare.

-R, --table-right coloane
    Aliniază textul la dreapta în coloanele specificate.

-T, --table-truncate coloane
    Specifică coloanele în care textul poate fi trunchiat atunci când este necesar, în caz contrar intrările foarte lungi din tabel pot fi imprimate pe mai multe linii.

-E, --table-noextreme coloane
    Specifică coloanele în care conținutul mai lung decât media trebuie ignorat la calcularea lățimii coloanei. Această opțiune influențează calculul lățimii și formatarea tabelului, dar textul afișat nu este afectat.

    Această opțiune este activată în mod implicit pentru ultima coloană vizibilă.

-e, --table-header-repeat
    Afișează linia de titlu pentru fiecare pagină.

-K, --table-header-as-columns
    Utilizează prima linie de intrare ca antet al tabelului. Această opțiune este incompatibilă cu opțiunile --table-columns și --table-column.

-W, --table-wrap coloane
    Specifică coloanele în care pot fi utilizate celule pe mai multe rânduri pentru textul lung. În mod implicit, textul se încadrează în funcție de lățimea coloanei. Utilizați --wrap-separator pentru a încadra textul în funcție de caractere de separare personalizate. Rețineți că antetul coloanei nu se încadrează niciodată și determină lățimea minimă a coloanei.

--wrap-separator șir
    Utilizează șir ca separator pentru încadrarea textului în coloanele în care este activată încadrarea. Separatorul este înlocuit cu caractere de linie nouă atunci când textul este afișat. Această opțiune necesită modul tabel și coloane cu încadrarea activată (a se vedea --table-wrap). De exemplu, utilizați „|” pentru a permite încadrarea la caracterele „pipe” (conductă) din datele coloanei.

-H, --table-hide coloane
    Nu imprimă coloanele specificate. Se poate utiliza simbolul special „-” pentru a ascunde toate coloanele nenumite (a se vedea --table-columns).

-O, --table-order coloane
    Specifică ordinea coloanelor de ieșire.

-n, --table-name nume
    Specifică numele tabelului utilizat pentru ieșirea JSON. Valoarea implicită este „table”.

-m, --table-maxout
    Ocupă tot spațiul disponibil la ieșire.

-L, --keep-empty-lines
    Păstrează liniile cu spații albe din datele de intrare. Valoarea implicită este de a ignora liniile goale. Numele original al acestei opțiuni a fost --table-empty-lines, dar de atunci a fost depreciat deoarece dă impresia falsă că opțiunea se aplică numai la modul tabel.

-r, --tree coloana
    Specifică coloana care urmează să fie utilizată pentru o ieșire de tip arbore. Rețineți că dependențele circulare și alte anomalii în relația proces-copil și proces-părinte sunt ignorate în tăcere.

-i, --tree-id coloana
    Specificați coloana care conține ID-ul unic al fiecărui proces-copil pentru o relație părinte-copil.

-p, --tree-parent coloana
    Specifică coloana care conține ID-ul unic ale proceselor-părinte pe fiecare linie pentru o relație copil-părinte.

-x, --fillrows
    Completează rândurile înainte de a completa coloanele.

--color[=când]
    Colorează ieșirea. Argumentul opțional când poate fi auto, never (niciodată) sau always (întotdeauna). În cazul în care argumentul când este omis, valoarea implicită este auto. Culorile pot fi dezactivate; pentru valoarea implicită încorporată curentă, consultați ieșirea --help. A se vedea, de asemenea, secțiunea CULORI de mai jos.

-h, --help
    Afișează acest mesaj de ajutor și iese.

-V, --version
    Afișează versiunea și iese.

CULORI

Colorarea ieșirii este implementată de funcționalitatea terminal-colors.d(5). Colorarea implicită poate fi dezactivată printr-un fișier gol

    /etc/terminal-colors.d/column.disable

pentru comanda column sau pentru toate instrumentele (comenzile) prin

    /etc/terminal-colors.d/disable

Începând cu versiunea 2.41, variabila de mediu $NO_COLOR este, de asemenea, acceptată pentru a dezactiva colorarea ieșirii, cu excepția cazului în care este activată explicit printr-o opțiune din linia de comandă.

Configurația specifică utilizatorului $XDG_CONFIG_HOME/terminal-colors.d sau $HOME/.config/terminal-colors.d prevalează asupra celei globale.

Rețineți că colorarea ieșirii poate fi activată în mod implicit și, în acest caz, directoarele terminal-colors.d nu trebuie să existe încă.

Numele schemei de culori implicite este „column” și poate fi modificat prin

    --table-colorscheme nume

Apoi, fișierul nume[.disable|enable|scheme] poate fi utilizat în /etc/terminal-colors.d/, $XDG_CONFIG_HOME/terminal-colors.d sau $HOME/.config/terminal-colors.d/.

Numele logic al culorii (cheia) din schema de culori poate fi specificat prin proprietățile coloanei colorkey= și headercolorkey=. De exemplu

    echo 'important red'           > ~/.config/terminal-colors.d/cooltable.scheme
    echo 'important-header 37;41' >> ~/.config/terminal-colors.d/cooltable.scheme
    echo -e "a b c\naa bb cc\naaa bbb ccc" | column -t \
            --table-colorscheme=cooltable \
            -C name=AAA,colorkey=important,headercolorkey=important-header \
            -C name=BBB,color=magenta,headercolor=cyan \
            -C name=CCC,color=green

Aceasta va crea o schemă de culori cu numele „cooltable” și va colora antetul și datele din prima coloană în conformitate cu cheile din schemă. Celelalte două coloane vor fi colorate folosind denumiri directe de culori.

MEDIU

COLUMNS
    este utilizată pentru a determina dimensiunea ecranului în cazul în care nu sunt disponibile alte informații.

LIBSMARTCOLS_DEBUG=all
    activează ieșirea de depanare a libsmartcols.

LIBSMARTCOLS_DEBUG_PADDING=on
    utilizează caractere de umplutură vizibile.

ISTORIC

Comanda column a apărut în 4.3BSD-Reno.

ERORI

Versiunea 2.23 a schimbat opțiunea -s pentru a nu fi „lacomă de spațiu”, de exemplu:

    printf "a:b:c\n1::3\n" | column -t -s ':'

Ieșirea veche:

    a  b  c
    1  3

Ieșirea nouă ( începând cu util-linux 2.23):

    a  b  c
    1     3

Versiunile istorice ale acestui instrument indicau că "rândurile sunt completate înaintea coloanelor" în mod implicit și că opțiunea -x inversează acest lucru. Această formulare nu reflecta comportamentul real, iar de atunci a fost corectată (a se vedea mai sus). Alte implementări ale column pot continua să utilizeze documentația mai veche, dar comportamentul ar trebui să fie identic în orice caz.

EXEMPLE

Afișează fstab cu linia de titlu și aliniază numerele la dreapta:

    sed 's/#.*//' /etc/fstab | column --table --table-columns SOURCE,TARGET,TYPE,OPTIONS,FREQ,PASS --table-right FREQ,PASS

Afișează fstab și ascunde coloanele care nu au fost numite:

    sed 's/#.*//' /etc/fstab | column --table --table-columns SOURCE,TARGET,TYPE --table-hide -

Afișează un arbore:

    echo -e '1 0 A\n2 1 AA\n3 1 AB\n4 2 AAA\n5 2 AAB' | column --tree-id 1 --tree-parent 2 --tree 3
    1  0  A
    2  1  |-AA
    4  2  | |-AAA
    5  2  | `-AAB
    3  1  `-AB

Imprimă tabelul cu separator de încadrare personalizat:

    echo -e 'Name:Description\nJohn:A|software|developer\nJane:A|data|scientist' | column --table --separator ':' --table-wrap 2 --wrap-separator '|'
    Name  Description
    John  A
          software
          developer
    Jane  A
          data
          scientist

CONSULTAȚI ȘI

colrm(1), ls(1), paste(1), sort(1)

RAPORTAREA ERORILOR

Pentru rapoarte de eroare, folosiți

DISPONIBILITATE

Comanda column face parte din pachetul util-linux care poate fi descărcat de la